﻿#pragma once

#include "..\..\DuiLib\UIlib.h"
#include "DuiDefine.h"
#include "ChatSearchList.hpp"

class CChatDlg;

class CChatSearchWnd : public WindowImplBase
{
    DUI_DECLARE_MESSAGE_MAP()
    DUI_DECLARE_CUSTOM_MSG_MAP()
public:
	CChatSearchWnd(CChatDlg *pChatDlg);
	~CChatSearchWnd();

	LPCTSTR GetWindowClassName() const;
	void InitWindow();

	//void UpdateFriendsList();
	void SetClientRect(CRect rc);
	int  GetChatSearchHeight();
	void SetChatSearchHeight(int nHeight, BOOL bResize = FALSE);
	HWND GetSafeHwnd(){return m_hWnd;}
	CChatSearchList* GetFriendsCtrl();
	CLabelUI* GetNosearchResultLabel();
	std::vector<CString> GetLeftListUserID();

	virtual CDuiString GetSkinFile();
	virtual CDuiString GetSkinFolder();
	virtual void OnFinalMessage(HWND hWnd);
	virtual CControlUI* CreateControl(LPCTSTR pstrClass);
	virtual LRESULT OnKillFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	virtual LRESULT OnNcHitTest(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
public:
	std::vector<ChatSearchItemInfo> m_vecfriend;

private:
    void _OnNotifyPrepare(TNotifyUI& msg);
    void _OnNotifyItemClick(TNotifyUI& msg);
    void _OnCtrlChatAddBtnClick(TNotifyUI& msg);

    LRESULT _OnMsgKeyDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT _OnMsgSysKeyDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT _OnMsgSize(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT _OnMsgActiveParent(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT _OnMsgInactiveHide(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
private:
	int m_nChatSearchHeight;
	CRect m_rcClient;
	ChatSearchItemInfo m_friendListInfo;
	CChatDlg *m_pChatDlg;
};
